'==============================================================
'=============== COPYRIGHT (C) JUSTEDUCATION.IR ===============
'===============           12/21/2017           ===============
'==============================================================

$regfile = "m32def.dat"
$crystal = 8000000

Enable Interrupts

Config Lcd = 20x4
Config Lcdpin = Pin , Db4 = Portb.4 , Db5 = Portb.5 , _
Db6 = Portb.6 , Db7 = Portb.7 , E = Portb.3 , Rs = Portb.2
Config Adc = Single , Prescaler = 128 , Reference = Avcc
Config Porta = Input
Config Portd.0 = Input
Config Portd.1 = Input
Config Portd.2 = Input
Config Portd.3 = Output
Config Portd.4 = Output
Config Portd.5 = Output
Config Portd.6 = Output
Config Portd.7 = Output

Relay Alias Portd.3
Red Alias Portd.5
Green Alias Portd.6
Blue Alias Portd.7

Dht_put Alias Portb.1
Dht_get Alias Pinb.1
Dht_io_set Alias Ddrb.1


Cursor Off
Cls

Declare Sub Get_th(t As Byte , H As Byte)
Declare Sub Up
Declare Sub Down
Declare Sub Menu

Dim Menu_counter As Bit
Dim Seconds_elapsed As Long
Dim Delay_required As Long
Dim Adc_value As Integer
Dim Volt As Single
Dim V_str As String * 10
Dim Ppm As Single
Dim Ppm_str As String * 10
Dim High_limit As Byte
Dim Low_limit As Byte

Dim T As Byte                                               'pereemennaya storage temperature
Dim H As Byte                                               'variable to store moisture
Dim Crc As Byte                                             'variable to store the parity bytes
Dim Mybyte As Byte
Dim Sensor_data As String * 40                              'here the data sent by the sensor will be recorded
Dim Tmp_str8 As String * 8
Dim Count As Byte                                           'variable for counting received bits

Set Dht_io_set
Set Dht_put


'================== Settings
High_limit = 30
Low_limit = 10
Delay_required = 5
'===========================

Do
   Debounce Pind.0 , 1 , Menu , Gosub
   Debounce Pind.1 , 1 , Up , Gosub
   Debounce Pind.2 , 1 , Down , Gosub

   '========================================================== Calculate and Display Values in PPM
   Call Get_th(t , H)
   Start Adc
   Adc_value = Getadc(1)
   Dim Temp As Single
   Volt = Adc_value * 0.004887585532746823069403714565
   V_str = Fusing(volt , "#.&&")
   Locate 1 , 1
   Lcd "Temp=" ; T ; "  " ; "Hum=" ; H ; "   "
   Locate 2 , 1
   Lcd "Low=" ; Low_limit ; " , " ; "High=" ; High_limit ; "   "

   Dim Temp1 As Single , Temp2 As Single

   'Temp1 = 1.2894 * Volt                                    'LPG Sensors
   'Temp2 = 2.71 ^ Temp1
   'Ppm = 26.572 * Temp2

   'Temp1 = 1.7742 * Volt                                    'Methane Sensors
   'Temp2 = 2.71 ^ Temp1
   'Ppm = 10.938 * Temp2

   Temp1 = 1.0698 * Volt                                    'CO Sensors
   Temp2 = 2.71 ^ Temp1
   Ppm = 3.027 * Temp2

   Locate 3 , 1

   Ppm_str = Fusing(ppm , "#.&&")
   Lcd "PPM = " ; Ppm_str ; " PPM  "

   '========================================================== Control System
   If Seconds_elapsed => Delay_required Then
      Dim Ppm_int As Integer
      Ppm_int = Ppm
      If T <= Low_limit Then
         Green = 0
         Red = 0
         Blue = 1
      Elseif T => High_limit Then
         Green = 0
         Red = 1
         Blue = 0
      Elseif T < High_limit And T > Low_limit Then
         Green = 1
         Red = 0
         Blue = 0
      Else
         Green = 0
         Red = 0
         Blue = 0
      End If
   End If

   Waitms 50
Loop
End

Menu:
   If Menu_counter = 0 Then Menu_counter = 1 Else Menu_counter = 0
Return

Up:
   If Menu_counter = 0 Then
      Incr Low_limit
   Elseif Menu_counter = 1 Then
      Incr High_limit
   End If
Return

Down:
   If Menu_counter = 0 Then
      Decr Low_limit
   Elseif Menu_counter = 1 Then
      Decr High_limit
   End If
Return

Sub Get_th(t As Byte , H As Byte)

   Count = 0
   Sensor_data = ""
   Set Dht_io_set                                             'do PD.6 output
   Reset Dht_put                                              'presses the tire to the ground
   Waitms 25                                                  'wait for at least 18ms

   Set Dht_put                                                'release the bus
   Waitus 40
   Reset Dht_io_set                                           'do PD.6 entrance
   Waitus 40                                                  'wait for 40 ms
   If Dht_get = 1 Then                                        'If it is still 1
      H = 1                                                   'means the sensor did not respond
      Exit Sub                                                'exit from the subroutine
   End If

'if the sensor is said and pulled the bus to continue to work the land
   Waitus 80                                                 'wait for another 80 ms
   If Dht_get = 0 Then                                       'If the line is still 0
      H = 2                                                   'means the sensor has gone mad
      Exit Sub                                                'exit from the subroutine
   End If

'if everything is fine and the sensor answered correctly, then continue

   While Dht_get = 1 : Wend                                  'waiting until you get on the bus 1

   Do                                                       'begin to take 40 bits of data
      While Dht_get = 0 : Wend                                'waiting for the appearance on the bus 0
      Waitus 30                                               '0 forward after the appearance 30mks
      If Dht_get = 1 Then                                    'if the tire 1
         Sensor_data = Sensor_data + "1"                      'write the variable unit
         While Dht_get = 1 : Wend                             'and wait until the sensor sends the next bit
      Else                                                 'otherwise, if there was a 0
         Sensor_data = Sensor_data + "0"                      'write the variable to 0
      End If
      Incr Count                                              'increment the counter by 1
   Loop Until Count = 40                                    'repeat until the counter has reached the count of 40

   Set Dht_io_set
   Set Dht_put

'we begin to lay out the data

   Tmp_str8 = Left(sensor_data , 8)                         'take a left 8 characters variable
   H = Binval(tmp_str8)                                     'This whole part of the humidity

   Tmp_str8 = Mid(sensor_data , 17 , 8)                     'pull out from the middle of 8 characters
   T = Binval(tmp_str8)                                     'This whole part of the temperature

   Tmp_str8 = Right(sensor_data , 8)                        'Right to 8 characters
   Crc = Binval(tmp_str8)                                   'inspection data



'checksum
   Mybyte = T + H                                           'add up the value of temperature and humidity
   If Mybyte <> Crc Then                                    'if the checksum will not match
      H = 3                                                 'means the data are not correct
   End If

End Sub

'==============================================================
'=============== COPYRIGHT (C) JUSTEDUCATION.IR ===============
'===============           12/21/2017           ===============
'==============================================================